#include "LM317.h"

extern PegBitmap gbimatgeBitmap;

LM317::LM317(PegRect rect, CPMainFrame* frame):CPModuleWindow(rect,0,0,frame)
{
 init();
}

int LM317::init()
{   
   	const WORD wStyle = FF_NONE|TJ_LEFT|AF_TRANSPARENT| TT_COPY;
	const SIGNED margin = 10;
	const SIGNED width=mClient.Width()-2*margin;
    
    PegRect rectangle;
 
	PegPrompt * Resultat1 = new PegPrompt(margin, 150, width, "Resultado:",0,wStyle);
	AddR(Resultat1);
	
	R1 = new CPPegString(margin+45,110,50, "240",0, FF_THIN|AF_ENABLED|EF_EDIT);
	AddR(R1);
	PegPrompt* Label_R1 = new PegPrompt(margin+25, 110, width, "R1:",0,wStyle);
	AddR(Label_R1);
	PegPrompt* Label_unitsR1 = new PegPrompt(margin+100, 110, 20, "Ohm",0,wStyle);
	AddR(Label_unitsR1);

    R2 = new CPPegString(margin,170,width, "R2:",0, wStyle);
    AddR(R2);
    
    rectangle.Set(70, 145, 130, 165);
	PegTextButton* b2 = new PegTextButton(rectangle, "Calcular", BOTO_2, AF_ENABLED|TJ_CENTER);
	AddR(b2);

    rectangle.Set(MAINFRAME_LEFT, MAINFRAME_TOP, MAINFRAME_RIGHT, MAINFRAME_TOP+90);
    PegBitmapButton *imatge = new PegBitmapButton(rectangle,&gbimatgeBitmap,0,AF_TRANSPARENT,TYPE_PROMPT,FALSE);
 	AddR(imatge);
   	
    Dada_v = new CPPegString(margin+45, 95, 50, "",0, FF_THIN|AF_ENABLED|EF_EDIT);
	PegPrompt* Label_v = new PegPrompt(margin+25, 95, width, "Vo:",0,wStyle);
	PegPrompt* Label_unitsv = new PegPrompt(margin+100, 95, 20, "V",0,wStyle);
	AddR(Label_v);
	AddR(Label_unitsv);
	AddR(Dada_v);
	
	return 0;
}
void LM317::Draw()
{
	BeginDraw();
	Invalidate(mClient);
	DrawFrame();
	DrawChildren();
	EndDraw();
}

SIGNED LM317::Message(const PegMessage &Mesg)
{
	switch(Mesg.wType)
	{
		case SIGNAL(BOTO_2, PSF_CLICKED):
		{		   
            Calcula_resistencies();
 		}
		break;
		default:
		return CPModuleWindow::Message(Mesg);
	}
	return 0;
}

void LM317::Calcula_resistencies()
{
   OBCD aux,aux2;
   aux=CPExpression(Dada_v->DataGet());
   ExecuteToOBCD("1.25", aux2);
   Cal_div_OBC(&aux,&aux2);
   ExecuteToOBCD("1", aux2);
   Cal_sub_OBC(&aux,&aux2);
   aux2=CPExpression(R1->DataGet());
   Cal_mul_OBC(&aux,&aux2);
   R2->DataSet(CPString("R2: ")+ CPString(aux)+ CPString(" Ohm"));
   Draw();
}
 
extern "C" char *ExtensionGetLang(ID_MESSAGE MessageNo)
{
   return "";
}
